declare function export_default$2(fn: Function, ctx: unknown): () => any;

declare function add(n1: number, n2: number): number;
declare function sub(n1: number, n2: number): number;
declare function mul(n1: number, n2: number): number;
declare function div(n1: number, n2: number): number;

declare function hasClass(element: HTMLElement, cls: string): boolean;
declare function addClass(element: HTMLElement, cls: string): void;
declare function removeClass(element: HTMLElement, cls: string): void;

declare function toRGB(color: string): {
    red: number;
    green: number;
    blue: number;
};
declare function rgba(color: string, alpha?: number): string;
/**
 * hex 2 rgba
 * @param color #000000 仅仅支持“HEX”字符串和“预留色彩”字符串
 * @param alpha 0 - 1 之间
 */
declare function hex2rgba(color: string, alpha?: number): string;

/**
 * 复制一份数据，仅支持基础类型和[object Object]类型以及[object Array]类型
 * 复杂的类型会给出警告，通过将第二个参数设置为 true 则关闭警告
 * @param source
 * @param silence 不打印警告
 * @example
 *  copy(1) => 1
 *  copy('2') => 2
 *  copy(null) => null
 *  copy(undefined) => undefined
 *  copy([1,3]) => [1,3]
 *  copy(Symbol(1)) => Symbol(1)
 *  copy(() => {}) => 产生警告
 *  copy(new Map()) => 产生警告
 *  ... 不一一列举
 */
declare function copy<T = unknown>(source: T, silence?: boolean): T;

declare const _default$2: (obj: object, key: string | symbol, value: any) => void;

declare const isClient: boolean;
declare const isFirefox: boolean;
declare const isAndroid: boolean;
declare const isOS: boolean;
declare const isWindowsPhone: boolean;
declare const isSymbianos: boolean;
declare const isMobile: boolean;

declare function getURLParam(name: string, search?: string): string | null;

declare function looseEqual(a: any, b: any): boolean;
declare function looseIndexOf(arr: any[], val: any): number;

declare const _default$1: () => void;

declare function getPathProp(target: Record<any, any>, path: string | Array<string>): any;
declare function setPathProp(target: Record<any, any>, path: string | Array<string>, value: any): boolean;

declare function setStorage(name: string, content: any): void;
declare function getStorage(name: string): string | void | null;
declare function removeStorage(name: string): void;

interface Options {
    id?: string;
    insertAt?: 'top' | 'bottom';
}
declare function styleInject(css: any, options?: Options): void;

/**
 * @description
 *  格式化时间
 *  yyyy 年
 *  MM 月
 *  dd 日
 *  HH 时
 *  mm 分
 *  ss 秒
 * @param {Date|string} time 时间，缺省则为当前时间
 * @param {string} format 格式，缺省则为 yyyy-MM-dd HH:mm:ss
 * @example
 *  toDateString() => 2020-03-05 11:46:22
 *  toDateString('2020-03-05 11:46:22', 'yyyy-MM-dd') => 2020-03-05
 */
declare function toDateString(time?: string | Date, format?: string): string;

declare const _default: (val: any) => any;

declare function export_default$1(string: string): string;

declare type Booleanish = boolean | 'true' | 'false';
declare const hasOwn: (val: object, key: string | symbol) => key is never;
declare const toRawType: (val: unknown) => string;
declare const isString: (val: unknown) => val is string;
declare const isNumber: (val: unknown) => val is number;
declare const isBoolean: (val: unknown) => val is boolean;
declare const isBooleanish: (val: any) => val is Booleanish;
declare const isSymbol: (val: unknown) => val is symbol;
declare const isRegExp: (val: unknown) => boolean;
declare const isNil: (val: unknown) => val is null | undefined;
declare const isNumeric: (val: unknown) => boolean;
declare const isDef: <T = any>(val?: T | undefined) => val is T;
declare const isDate: (val: unknown) => val is Date;
declare const isFunction: (val: unknown) => val is Function;
declare const isArray: (arg: any) => arg is any[];
declare const isObject: (val: unknown) => val is Record<any, any>;
declare const isPromise: <T = any>(val: unknown) => val is Promise<T>;
declare const isPlainObject: (val: unknown) => val is object;
declare const isEmptyObject: (val: any) => val is Record<any, any>;

declare function export_default(): string;

declare const validateURL: (val: string) => boolean;
declare const validateEmail: (val: string) => boolean;
declare const validateLetter: (val: string) => boolean;
declare const validateMobileNumber: (val: string) => boolean;

declare const version = "2.0.5";

export { Booleanish, add, addClass, export_default$2 as bindFn, copy, _default$2 as def, div, getPathProp, getStorage, getURLParam, hasClass, hasOwn, hex2rgba, isAndroid, isArray, isBoolean, isBooleanish, isClient, isDate, isDef, isEmptyObject, isFirefox, isFunction, isMobile, isNil, isNumber, isNumeric, isOS, isObject, isPlainObject, isPromise, isRegExp, isString, isSymbianos, isSymbol, isWindowsPhone, looseEqual, looseIndexOf, mul, _default$1 as noop, removeClass, removeStorage, rgba, setPathProp, setStorage, styleInject, sub, toDateString, _default as toNumber, toRGB, toRawType, export_default$1 as trim, export_default as uuid, validateEmail, validateLetter, validateMobileNumber, validateURL, version };
