function bindFn(fn, ctx) {
  const slice = Array.prototype.slice;
  const args = slice.call(arguments, 2);
  return function() {
    return fn.apply(ctx, args.concat(slice.call(arguments)));
  };
}
function add(n1, n2) {
  const s1 = n1.toString();
  const s2 = n2.toString();
  const arr1 = s1.split(".");
  const arr2 = s2.split(".");
  const d1 = arr1.length === 2 ? arr1[1] : "";
  const d2 = arr2.length === 2 ? arr2[1] : "";
  const maxLen = Math.max(d1.length, d2.length);
  const m = Math.pow(10, maxLen);
  return Number(((Number(s1) * m + Number(s2) * m) / m).toFixed(maxLen));
}
function sub(n1, n2) {
  return add(n1, -n2);
}
function mul(n1, n2) {
  let m = 0;
  const s1 = n1.toString();
  const s2 = n2.toString();
  try {
    m += s1.split(".")[1].length;
  } catch (e) {
  }
  try {
    m += s2.split(".")[1].length;
  } catch (e) {
  }
  return Number(s1.replace(".", "")) * Number(s2.replace(".", "")) / Math.pow(10, m);
}
function div(n1, n2) {
  let t1 = 0;
  let t2 = 0;
  try {
    t1 = n1.toString().split(".")[1].length;
  } catch (e) {
  }
  try {
    t2 = n2.toString().split(".")[1].length;
  } catch (e) {
  }
  const r1 = Number(n1.toString().replace(".", ""));
  const r2 = Number(n2.toString().replace(".", ""));
  return t1 < t2 ? r1 / r2 * Math.pow(10, t2 - t1) : r1 / r2 / Math.pow(10, t1 - t2);
}
function trim(string) {
  return (string || "").replace(/^[\s\uFEFF]+|[\s\uFEFF]+$/g, "");
}
function hasClass(element, cls) {
  if (!element || !cls)
    return false;
  if (cls.indexOf(" ") !== -1)
    throw new Error("className should not contain space.");
  if (element.classList) {
    return element.classList.contains(cls);
  } else {
    return (" " + element.className + " ").indexOf(" " + cls + " ") > -1;
  }
}
function addClass(element, cls) {
  if (!element)
    return;
  let curClass = element.className;
  const classes = (cls || "").split(" ");
  for (let i = 0, j = classes.length; i < j; i++) {
    const clsName = classes[i];
    if (!clsName)
      continue;
    if (element.classList) {
      element.classList.add(clsName);
    } else if (!hasClass(element, clsName)) {
      curClass += " " + clsName;
    }
  }
  if (!element.classList) {
    element.className = curClass;
  }
}
function removeClass(element, cls) {
  if (!element || !cls)
    return;
  const classes = cls.split(" ");
  let curClass = " " + element.className + " ";
  for (let i = 0, j = classes.length; i < j; i++) {
    const clsName = classes[i];
    if (!clsName)
      continue;
    if (element.classList) {
      element.classList.remove(clsName);
    } else if (hasClass(element, clsName)) {
      curClass = curClass.replace(" " + clsName + " ", " ");
    }
  }
  if (!element.classList) {
    element.className = trim(curClass);
  }
}
const colors = Object.freeze({
  aliceblue: "#f0f8ff",
  antiquewhite: "#faebd7",
  aqua: "#00ffff",
  aquamarine: "#7fffd4",
  azure: "#f0ffff",
  beige: "#f5f5dc",
  bisque: "#ffe4c4",
  black: "#000000",
  blanchedalmond: "#ffebcd",
  blue: "#0000ff",
  blueviolet: "#8a2be2",
  brown: "#a52a2a",
  burlywood: "#deb887",
  cadetblue: "#5f9ea0",
  chartreuse: "#7fff00",
  chocolate: "#d2691e",
  coral: "#ff7f50",
  cornflowerblue: "#6495ed",
  cornsilk: "#fff8dc",
  crimson: "#dc143c",
  cyan: "#00ffff",
  darkblue: "#00008b",
  darkcyan: "#008b8b",
  darkgoldenrod: "#b8860b",
  darkgray: "#a9a9a9",
  darkgrey: "#a9a9a9",
  darkgreen: "#006400",
  darkkhaki: "#bdb76b",
  darkmagenta: "#8b008b",
  darkolivegreen: "#556b2f",
  darkorange: "#ff8c00",
  darkorchid: "#9932cc",
  darkred: "#8b0000",
  darksalmon: "#e9967a",
  darkseagreen: "#8fbc8f",
  darkslateblue: "#483d8b",
  darkslategray: "#2f4f4f",
  darkslategrey: "#2f4f4f",
  darkturquoise: "#00ced1",
  darkviolet: "#9400d3",
  deeppink: "#ff1493",
  deepskyblue: "#00bfff",
  dimgray: "#696969",
  dimgrey: "#696969",
  dodgerblue: "#1e90ff",
  firebrick: "#b22222",
  floralwhite: "#fffaf0",
  forestgreen: "#228b22",
  fuchsia: "#ff00ff",
  gainsboro: "#dcdcdc",
  ghostwhite: "#f8f8ff",
  gold: "#ffd700",
  goldenrod: "#daa520",
  gray: "#808080",
  grey: "#808080",
  green: "#008000",
  greenyellow: "#adff2f",
  honeydew: "#f0fff0",
  hotpink: "#ff69b4",
  indianred: "#cd5c5c",
  indigo: "#4b0082",
  ivory: "#fffff0",
  khaki: "#f0e68c",
  lavender: "#e6e6fa",
  lavenderblush: "#fff0f5",
  lawngreen: "#7cfc00",
  lemonchiffon: "#fffacd",
  lightblue: "#add8e6",
  lightcoral: "#f08080",
  lightcyan: "#e0ffff",
  lightgoldenrodyellow: "#fafad2",
  lightgray: "#d3d3d3",
  lightgrey: "#d3d3d3",
  lightgreen: "#90ee90",
  lightpink: "#ffb6c1",
  lightsalmon: "#ffa07a",
  lightseagreen: "#20b2aa",
  lightskyblue: "#87cefa",
  lightslategray: "#778899",
  lightslategrey: "#778899",
  lightsteelblue: "#b0c4de",
  lightyellow: "#ffffe0",
  lime: "#00ff00",
  limegreen: "#32cd32",
  linen: "#faf0e6",
  magenta: "#ff00ff",
  maroon: "#800000",
  mediumaquamarine: "#66cdaa",
  mediumblue: "#0000cd",
  mediumorchid: "#ba55d3",
  mediumpurple: "#9370d8",
  mediumseagreen: "#3cb371",
  mediumslateblue: "#7b68ee",
  mediumspringgreen: "#00fa9a",
  mediumturquoise: "#48d1cc",
  mediumvioletred: "#c71585",
  midnightblue: "#191970",
  mintcream: "#f5fffa",
  mistyrose: "#ffe4e1",
  moccasin: "#ffe4b5",
  navajowhite: "#ffdead",
  navy: "#000080",
  oldlace: "#fdf5e6",
  olive: "#808000",
  olivedrab: "#6b8e23",
  orange: "#ffa500",
  orangered: "#ff4500",
  orchid: "#da70d6",
  palegoldenrod: "#eee8aa",
  palegreen: "#98fb98",
  paleturquoise: "#afeeee",
  palevioletred: "#d87093",
  papayawhip: "#ffefd5",
  peachpuff: "#ffdab9",
  peru: "#cd853f",
  pink: "#ffc0cb",
  plum: "#dda0dd",
  powderblue: "#b0e0e6",
  purple: "#800080",
  rebeccapurple: "#663399",
  red: "#ff0000",
  rosybrown: "#bc8f8f",
  royalblue: "#4169e1",
  saddlebrown: "#8b4513",
  salmon: "#fa8072",
  sandybrown: "#f4a460",
  seagreen: "#2e8b57",
  seashell: "#fff5ee",
  sienna: "#a0522d",
  silver: "#c0c0c0",
  skyblue: "#87ceeb",
  slateblue: "#6a5acd",
  slategray: "#708090",
  slategrey: "#708090",
  snow: "#fffafa",
  springgreen: "#00ff7f",
  steelblue: "#4682b4",
  tan: "#d2b48c",
  teal: "#008080",
  thistle: "#d8bfd8",
  tomato: "#ff6347",
  turquoise: "#40e0d0",
  violet: "#ee82ee",
  wheat: "#f5deb3",
  white: "#ffffff",
  whitesmoke: "#f5f5f5",
  yellow: "#ffff00",
  yellowgreen: "#9acd32"
});
function toRGB(color) {
  color = color.replace("#", "");
  if (/^[0-9a-fA-F]{3}$/.test(color)) {
    const colorArray = color.split("");
    for (let i = 2; i >= 0; i--) {
      colorArray.splice(i, 0, colorArray[i]);
    }
    color = colorArray.join("");
  }
  if (/^[0-9a-fA-F]{6}$/.test(color)) {
    return {
      red: parseInt(color.slice(0, 2), 16),
      green: parseInt(color.slice(2, 4), 16),
      blue: parseInt(color.slice(4, 6), 16)
    };
  } else {
    return {
      red: 255,
      green: 255,
      blue: 255
    };
  }
}
function rgba(color, alpha = 1) {
  color = colors[color] ? colors[color] : color;
  return hex2rgba(color, alpha);
}
function hex2rgba(color, alpha = 1) {
  const { red, green, blue } = toRGB(color);
  alpha = +alpha;
  return alpha >= 1 || alpha < 0 ? `rgb(${Math.round(red)}, ${Math.round(green)}, ${Math.round(blue)})` : `rgba(${Math.round(red)}, ${Math.round(green)}, ${Math.round(
    blue
  )}, ${alpha})`;
}
const _toString = Object.prototype.toString;
const _hasOwn = Object.prototype.hasOwnProperty;
const hasOwn = (val, key) => _hasOwn.call(val, key);
const toRawType = (val) => _toString.call(val).slice(8, -1);
const isString = (val) => typeof val === "string";
const isNumber = (val) => typeof val === "number";
const isBoolean = (val) => typeof val === "boolean";
const isBooleanish = (val) => isBoolean(val) || val === "true" || val === "false";
const isSymbol = (val) => typeof val === "symbol";
const isRegExp = (val) => _toString.call(val) === "[object RegExp]";
const isNil = (val) => val == null;
const isNumeric = (val) => !isNaN(parseFloat(val)) && isFinite(val);
const isDef = (val) => !isNil(val);
const isDate = (val) => val instanceof Date;
const isFunction = (val) => typeof val === "function" || _toString.call(val) === "[object Function]";
const isArray = Array.isArray;
const isObject = (val) => val !== null && typeof val === "object";
const isPromise = (val) => isObject(val) && isFunction(val.then) && isFunction(val.catch);
const isPlainObject = (val) => {
  if (isObject(val) === false)
    return false;
  const ctor = val.constructor;
  const proto = ctor.prototype;
  return isFunction(ctor) && isObject(proto) && hasOwn(proto, "isPrototypeOf") !== false;
};
const isEmptyObject = (val) => {
  if (!isPlainObject(val))
    return false;
  for (const _k in val) {
    return false;
  }
  return true;
};
const EnableCopyList = "Number,String,Boolean,Null,Undefined,Symbol,BigInt,Object,Array".split(",");
function copy(source, silence = false) {
  let copyOne;
  if (isPlainObject(source)) {
    copyOne = {};
    for (const prop in source) {
      copyOne[prop] = copy(source[prop], silence);
    }
  } else if (isArray(source)) {
    copyOne = [];
    for (const item of source) {
      copyOne.push(copy(item, silence));
    }
  } else {
    const rawType = toRawType(source);
    if (!EnableCopyList.includes(rawType) && !silence) {
      console.warn(
        `The [${rawType}] type property of the current target '${source}' cannot be copied.`
      );
    }
    copyOne = source;
  }
  return copyOne;
}
var def = (obj, key, value) => {
  Object.defineProperty(obj, key, {
    configurable: true,
    enumerable: false,
    value
  });
};
const isClient = typeof window !== "undefined";
const userAgent = isClient ? window.navigator.userAgent.toLowerCase() : "node_env";
const isFirefox = userAgent.indexOf("firefox") >= 0;
const isAndroid = userAgent.indexOf("android") >= 0;
const isOS = /(iphone|ipad|ipod|ios)/.test(userAgent);
const isWindowsPhone = userAgent.indexOf("windows phone") >= 0;
const isSymbianos = userAgent.indexOf("symbianos") >= 0;
const isMobile = isAndroid || isOS || isWindowsPhone || isSymbianos;
function getURLParam(name, search = location.search) {
  const rx = new RegExp(`[?|&]${name}=([^&;]+?)(&|#|;|$)`);
  const ar = rx.exec(search);
  return ar && ar.length > 1 ? decodeURIComponent(ar[1].replace(/\+/g, "%20")) : null;
}
function looseCompareArrays(a, b) {
  if (a.length !== b.length)
    return false;
  let equal = true;
  for (let i = 0; equal && i < a.length; i++) {
    equal = looseEqual(a[i], b[i]);
  }
  return equal;
}
function looseEqual(a, b) {
  if (a === b)
    return true;
  let aValidType = isDate(a);
  let bValidType = isDate(b);
  if (aValidType || bValidType) {
    return aValidType && bValidType ? a.getTime() === b.getTime() : false;
  }
  aValidType = isArray(a);
  bValidType = isArray(b);
  if (aValidType || bValidType) {
    return aValidType && bValidType ? looseCompareArrays(a, b) : false;
  }
  aValidType = isObject(a);
  bValidType = isObject(b);
  if (aValidType || bValidType) {
    if (!aValidType || !bValidType) {
      return false;
    }
    const aKeysCount = Object.keys(a).length;
    const bKeysCount = Object.keys(b).length;
    if (aKeysCount !== bKeysCount) {
      return false;
    }
    for (const key in a) {
      const aHasKey = hasOwn(a, key);
      const bHasKey = hasOwn(b, key);
      if (aHasKey && !bHasKey || !aHasKey && bHasKey || !looseEqual(a[key], b[key])) {
        return false;
      }
    }
  }
  return String(a) === String(b);
}
function looseIndexOf(arr, val) {
  return arr.findIndex((item) => looseEqual(item, val));
}
var noop = () => {
};
function getPathProp(target, path) {
  if (!isObject(target))
    return null;
  const pathList = isString(path) ? path.split(".") : isArray(path) ? path : [];
  const currentKey = pathList.shift();
  const currentValue = currentKey ? target[currentKey] : null;
  return pathList.length ? getPathProp(currentValue, pathList) : currentValue;
}
function setPathProp(target, path, value) {
  const _setPathProp = (target2, path2, value2) => {
    const pathList = isString(path2) ? path2.split(".") : isArray(path2) ? path2 : [];
    const currentKey = pathList.shift();
    if (isNil(target2) || isNil(currentKey))
      return false;
    if (pathList.length > 0) {
      return _setPathProp(target2[currentKey], pathList, value2);
    } else {
      try {
        target2[currentKey] = value2;
        return true;
      } catch (e) {
        return false;
      }
    }
  };
  return isObject(target) ? _setPathProp(target, path, value) : false;
}
const storage = isClient ? window.localStorage || window.sessionStorage : {
  setItem: noop,
  getItem: noop,
  removeItem: noop
};
function setStorage(name, content) {
  if (!name)
    return;
  if (typeof content !== "string") {
    content = JSON.stringify(content);
  }
  storage.setItem(name, content);
}
function getStorage(name) {
  if (!name)
    return;
  return storage.getItem(name);
}
function removeStorage(name) {
  if (!name)
    return;
  storage.removeItem(name);
}
function styleInject(css, options = {}) {
  const { insertAt, id } = options;
  if (!css || typeof document === "undefined")
    return;
  const domHead = document.head || document.getElementsByTagName("head")[0];
  const domStyle = document.createElement("style");
  domStyle.type = "text/css";
  if (id)
    domStyle.id = id;
  if (insertAt === "top") {
    domHead.firstChild ? domHead.insertBefore(domStyle, domHead.firstChild) : domHead.appendChild(domStyle);
  } else {
    domHead.appendChild(domStyle);
  }
  if (domStyle.styleSheet) {
    domStyle.styleSheet.cssText = css;
  } else {
    domStyle.appendChild(document.createTextNode(css));
  }
}
const digit = (number, length = 2) => ("" + number).padStart(length, "0");
function toDateString(time = new Date(), format = "yyyy-MM-dd HH:mm:ss") {
  time = isString(time) ? time.replace(/-/g, "/") : time;
  const date = new Date(time);
  const ymd = [
    digit(date.getFullYear(), 4),
    digit(date.getMonth() + 1),
    digit(date.getDate())
  ];
  const hms = [
    digit(date.getHours()),
    digit(date.getMinutes()),
    digit(date.getSeconds())
  ];
  return format.replace(/yyyy/g, ymd[0]).replace(/MM/g, ymd[1]).replace(/dd/g, ymd[2]).replace(/HH/g, hms[0]).replace(/mm/g, hms[1]).replace(/ss/g, hms[2]);
}
var toNumber = (val) => {
  const n = parseFloat(val);
  return isNaN(n) ? val : n;
};
function uuid() {
  const s4 = () => Math.floor((1 + Math.random()) * 65536).toString(16).substring(1);
  return s4() + s4() + "-" + s4() + "-" + s4() + "-" + s4() + "-" + s4() + s4() + s4();
}
const urlRE = /^(https?|ftp):\/\/([a-zA-Z0-9.-]+(:[a-zA-Z0-9.&%$-]+)*@)*((25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]?)(\.(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9]?[0-9])){3}|([a-zA-Z0-9-]+\.)*[a-zA-Z0-9-]+\.(com|edu|gov|int|mil|net|org|biz|arpa|info|name|pro|aero|coop|museum|[a-zA-Z]{2}))(:[0-9]+)*(\/($|[a-zA-Z0-9.,?'\\+&%$#=~_-]+))*$/;
const emailRE = /^([a-zA-Z0-9_.-])+@(([a-zA-Z0-9-])+\.)+([a-zA-Z0-9]{2,4})+$/;
const letterRE = /^[A-Za-z]+$/;
const mobileNumberRE = /(^\d{15}$)|(^\d{17}(x|X|\d)$)/;
const validateURL = (val) => urlRE.test(val);
const validateEmail = (val) => emailRE.test(val);
const validateLetter = (val) => letterRE.test(val);
const validateMobileNumber = (val) => mobileNumberRE.test(val);
const version = "2.0.5";
export { add, addClass, bindFn, copy, def, div, getPathProp, getStorage, getURLParam, hasClass, hasOwn, hex2rgba, isAndroid, isArray, isBoolean, isBooleanish, isClient, isDate, isDef, isEmptyObject, isFirefox, isFunction, isMobile, isNil, isNumber, isNumeric, isOS, isObject, isPlainObject, isPromise, isRegExp, isString, isSymbianos, isSymbol, isWindowsPhone, looseEqual, looseIndexOf, mul, noop, removeClass, removeStorage, rgba, setPathProp, setStorage, styleInject, sub, toDateString, toNumber, toRGB, toRawType, trim, uuid, validateEmail, validateLetter, validateMobileNumber, validateURL, version };
