import { isArray, isObject, isString, isNil } from './type';

export function getPathProp(
  target: Record<any, any>,
  path: string | Array<string>
): any {
  if (!isObject(target)) return null;

  const pathList = isString(path) ? path.split('.') : isArray(path) ? path : [];
  const currentKey = pathList.shift();
  const currentValue = currentKey ? target[currentKey] : null;
  return pathList.length ? getPathProp(currentValue, pathList) : currentValue;
}

export function setPathProp(
  target: Record<any, any>,
  path: string | Array<string>,
  value: any
): boolean {
  const _setPathProp = (
    target: Record<any, any>,
    path: string | Array<string>,
    value: any
  ): boolean => {
    const pathList = isString(path)
      ? path.split('.')
      : isArray(path)
        ? path
        : [];
    const currentKey = pathList.shift();

    if (isNil(target) || isNil(currentKey)) return false;

    if (pathList.length > 0) {
      return _setPathProp(target[currentKey], pathList, value);
    } else {
      try {
        target[currentKey] = value;
        return true;
      } catch (e) {
        return false;
      }
    }
  };
  return isObject(target) ? _setPathProp(target, path, value) : false;
}
