import { isClient } from './env';
import noop from './noop';
const storage = isClient
  ? window.localStorage || window.sessionStorage
  : {
    setItem: noop,
    getItem: noop,
    removeItem: noop
  };

export function setStorage(name: string, content: any) {
  if (!name) return;
  if (typeof content !== 'string') {
    content = JSON.stringify(content);
  }
  storage.setItem(name, content);
}

export function getStorage(name: string) {
  if (!name) return;
  return storage.getItem(name);
}

export function removeStorage(name: string) {
  if (!name) return;
  storage.removeItem(name);
}
