const urlRE =
  /^(https?|ftp):\/\/([a-zA-Z0-9.-]+(:[a-zA-Z0-9.&%$-]+)*@)*((25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]?)(\.(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9]?[0-9])){3}|([a-zA-Z0-9-]+\.)*[a-zA-Z0-9-]+\.(com|edu|gov|int|mil|net|org|biz|arpa|info|name|pro|aero|coop|museum|[a-zA-Z]{2}))(:[0-9]+)*(\/($|[a-zA-Z0-9.,?'\\+&%$#=~_-]+))*$/;
const emailRE = /^([a-zA-Z0-9_.-])+@(([a-zA-Z0-9-])+\.)+([a-zA-Z0-9]{2,4})+$/;
const letterRE = /^[A-Za-z]+$/;
const mobileNumberRE = /(^\d{15}$)|(^\d{17}(x|X|\d)$)/;

export const validateURL = (val: string) => urlRE.test(val);
export const validateEmail = (val: string) => emailRE.test(val);
export const validateLetter = (val: string) => letterRE.test(val);
export const validateMobileNumber = (val: string) => mobileNumberRE.test(val);
