import { add, sub, mul, div } from '../src/calc';

const n1 = 14;
const n2 = 0.1;
const n3 = 0.400001;
const n4 = 0.02;

test('util: add', () => {
  expect(add(n1, n2)).toBe(n1 + n2);
  expect(add(NaN, NaN)).toBe(NaN * NaN);
  expect(add(Infinity, Infinity)).toBe(Infinity + Infinity);
  expect(add(-Infinity, Infinity)).toBe(-Infinity + Infinity);
  expect(add(-Infinity, -Infinity)).toBe(-Infinity + -Infinity);
});

test('util: sub', () => {
  expect(sub(n2, n1)).toBe(n2 - n1);
  expect(sub(NaN, NaN)).toBe(NaN * NaN);
  expect(sub(Infinity, Infinity)).toBe(Infinity - Infinity);
  expect(sub(-Infinity, Infinity)).toBe(-Infinity - Infinity);
  expect(sub(-Infinity, -Infinity)).toBe(-Infinity - -Infinity);
});

test('util: mul', () => {
  expect(mul(n2, n1)).toBe(1.4);
  expect(mul(n2, n1)).not.toEqual(n2 * n1);
  expect(mul(NaN, NaN)).toBe(NaN * NaN);
  expect(mul(NaN, Infinity)).toBe(NaN * Infinity);
  expect(mul(Infinity, Infinity)).toBe(Infinity * Infinity);
  expect(mul(Infinity, -2)).toBe(Infinity * -2);
  expect(mul(Infinity, 2)).toBe(Infinity * 2);
  expect(mul(Infinity, 0)).toBe(Infinity * 0);
});

test('util: div', () => {
  expect(div(n3, n4)).toBe(20.00005);
  expect(div(n3, n4)).not.toEqual(n3 / n4);
  expect(div(n3, 0)).toBe(Infinity);
  expect(div(0, 0)).toBe(NaN);
  expect(div(Infinity, Infinity)).toBeNaN;
  expect(div(NaN, NaN)).toBeNaN;
});
