import { hasClass, addClass, removeClass } from '../src/className';

const dom = document.createElement('div');
dom.className = 'bg-transparent px-1';

test('util: hasClass', () => {
  expect(hasClass(dom, '')).toBe(false);
  expect(hasClass(dom, 'px-1')).toBe(true);
  expect(hasClass(dom, 'px-2')).toBe(false);
});

test('util: addClass', () => {
  function WrapperDo() {
    addClass(dom, 'mx-2');
    addClass(dom, 'br-1');
    addClass(dom, 'px-1');
    return dom.className;
  }
  expect(WrapperDo()).toBe('bg-transparent px-1 mx-2 br-1');
});

test('util: removeClass', () => {
  function WrapperDo() {
    removeClass(dom, 'px-1');
    removeClass(dom, 'mx-2');
    return dom.className;
  }
  expect(WrapperDo()).toBe('bg-transparent br-1');
});
