import { getPathProp, setPathProp } from '../src/pathProp';

test('util: getPathProp', () => {
  const target = {
    a: 1,
    b: [2, 3],
    hi: (m: string) => console.log(m), // 被 JSON.stringify 过滤
    o: {
      i: '壹',
      ii: '贰',
      iiis: ['叁', '肆']
    },
    m: Math
  };
  expect(getPathProp(target, 'm.PI')).toEqual(Math.PI);
  expect(getPathProp(target, ['o', 'i'])).toBe('壹');
  expect(getPathProp(target, 'b.0')).toBe(2);
  expect(getPathProp(target, ['b', '1'])).toBe(3);
  expect(getPathProp(target, 'hi')).toEqual(target.hi);
});

test('util: setPathProp', () => {
  const target = {
    a: 1,
    b: [2, 3],
    hi: (m: string) => console.log(m), // 被 JSON.stringify 过滤
    o: {
      i: '壹',
      ii: '贰',
      iiis: ['叁', '肆']
    },
    m: Math
  };
  expect(setPathProp(target, 'a', 2)).toBe(true);
  expect(setPathProp(target, ['b', '1'], 4)).toEqual(true);
  expect(setPathProp(target, 'o.iiis.0', 'TEST')).toEqual(true);
  expect(setPathProp(target, 'hi.name', 'hi')).toEqual(false);
  expect(setPathProp(target, 'o.g', 2)).toBe(true);
  expect(setPathProp(target, 'o.h.k', 2)).toBe(false);

  console.log(target);
});
